package org.commonjava.tensor.flat.config;

import java.io.File;
import java.util.Map;

import javax.enterprise.inject.Alternative;
import javax.inject.Named;

@Alternative
@Named( "dont-use-directly" )
public class FlatFileTensorConfiguration
{

    private File storageBasedir;

    private String defaultCacheConfig;

    private Map<String, String> cacheConfigs;

    public FlatFileTensorConfiguration()
    {
    }

    public FlatFileTensorConfiguration( final File storageBasedir, final Map<String, String> cacheConfigs )
    {
        this.storageBasedir = storageBasedir;
        this.cacheConfigs = cacheConfigs;
    }

    public File getStorageBasedir()
    {
        return storageBasedir;
    }

    public void setStorageBasedir( final File storageBasedir )
    {
        this.storageBasedir = storageBasedir;
    }

    public Map<String, String> getCacheConfigs()
    {
        return cacheConfigs;
    }

    public void setCacheConfigs( final Map<String, String> cacheConfigs )
    {
        this.cacheConfigs = cacheConfigs;
    }

    public String getCacheConfig( final String name )
    {
        return cacheConfigs == null ? null : cacheConfigs.get( name );
    }

    public String getDefaultCacheConfig()
    {
        return defaultCacheConfig;
    }

    public void setDefaultCacheConfig( final String defaultCacheConfig )
    {
        this.defaultCacheConfig = defaultCacheConfig;
    }

}
