package org.commonjava.tensor.flat.data.store;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

import org.commonjava.tensor.data.store.IndexStore;
import org.commonjava.tensor.data.store.IndexStoreFactory;
import org.commonjava.tensor.flat.config.FlatFileTensorConfiguration;
import org.commonjava.tensor.inject.TensorData;
import org.commonjava.web.json.ser.JsonSerializer;

import com.google.gson.reflect.TypeToken;

@ApplicationScoped
public class FlatFileIndexStoreFactory
    implements IndexStoreFactory
{

    @Inject
    private FlatFileTensorConfiguration config;

    @Inject
    @TensorData
    private JsonSerializer serializer;

    public FlatFileIndexStoreFactory()
    {
    }

    public FlatFileIndexStoreFactory( final FlatFileTensorConfiguration config, final JsonSerializer serializer )
    {
        this.config = config;
        this.serializer = serializer;
    }

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType, final Class<V> valueType )
    {
        return new FlatFileIndexStore<K, V>( name, valueType, serializer, config );
    }

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType,
                                             final TypeToken<V> constituentType )
    {
        return new FlatFileIndexStore<K, V>( name, constituentType, serializer, config );
    }

}
